#include <d3d9.h>
#include "WebControl.h"
#pragma warning( disable : 4996 )
#include <strsafe.h>
#pragma warning( default : 4996 ) 


LPDIRECT3D9             g_pD3D       = NULL;
LPDIRECT3DDEVICE9       g_pd3dDevice = NULL;

HWND					m_hWnd = NULL;
HWND					m_hExplorerhWnd = NULL;
#define WEB_SCREEN_LEFT		100
#define WEB_SCREEN_TOP		100
#define WEB_SCREEN_RIGHT	700
#define WEB_SCREEN_BOTTOM	500



HRESULT InitD3D( HWND hWnd )
{
    if( NULL == ( g_pD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;

    D3DPRESENT_PARAMETERS d3dpp; 
    ZeroMemory( &d3dpp, sizeof(d3dpp) );
    d3dpp.Windowed = TRUE;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;

    if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                                      D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                                      &d3dpp, &g_pd3dDevice ) ) )
    {
        return E_FAIL;
    }

	if( false == InitWebCtrl() )
	{
		MessageBox( NULL, "WebControl ʱȭ ", "", MB_OK );
		return E_FAIL;
	}
	m_hExplorerhWnd = CreateWebControl( "http://blog.naver.com/goli81", WS_OVERLAPPED | WS_CHILD, WEB_SCREEN_LEFT, WEB_SCREEN_TOP,
		WEB_SCREEN_RIGHT - WEB_SCREEN_LEFT, WEB_SCREEN_BOTTOM - WEB_SCREEN_TOP, m_hWnd, NULL);
	::ShowWindow(m_hExplorerhWnd,SW_SHOW);

    return S_OK;
}


VOID Cleanup()
{
	UninitWebCtrl();

    if( g_pd3dDevice != NULL) 
        g_pd3dDevice->Release();

    if( g_pD3D != NULL)
        g_pD3D->Release();
}



VOID Render()
{
    if( NULL == g_pd3dDevice )
        return;

    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET, D3DCOLOR_XRGB(0,0,255), 1.0f, 0 );
    
    if( SUCCEEDED( g_pd3dDevice->BeginScene() ) )
    {
        g_pd3dDevice->EndScene();
    }

    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );
}


LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_DESTROY:
            Cleanup();
            PostQuitMessage( 0 );
            return 0;

        case WM_PAINT:
            Render();
            ValidateRect( hWnd, NULL );
            return 0;
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}




INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L, 
                      GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
                      "D3D WebPage", NULL };
    RegisterClassEx( &wc );

    m_hWnd = CreateWindow( "D3D WebPage", "D3D WebPage Viewer", 
                              WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS, 100, 100, 800, 600,
                              NULL, NULL, wc.hInstance, NULL );

    if( SUCCEEDED( InitD3D( m_hWnd ) ) )
    { 
        ShowWindow( m_hWnd, SW_SHOWDEFAULT );
        UpdateWindow( m_hWnd );

        MSG msg; 
        while( GetMessage( &msg, NULL, 0, 0 ) )
        {
            TranslateMessage( &msg );
            DispatchMessage( &msg );
        }
    }

    UnregisterClass( "D3D WebPage", wc.hInstance );
    return 0;
}



